Bug 7681 - ICE in compensate_edge, at reg-stack.c:2591
Summary: ICE in compensate_edge, at reg-stack.c:2591
Status: RESOLVED FIXED
Alias: None
Product: gcc
Classification: Unclassified
Component: fortran (show other bugs)
Version: unknown
: P3 normal
Target Milestone: ---
Assignee: Not yet assigned to anyone
URL:
Keywords: ice-on-valid-code
: 9276 (view as bug list)
Depends on:
Blocks:
 
Reported: 2002-08-22 03:56 UTC by werner.koerner
Modified: 2003-07-25 17:33 UTC (History)
2 users (show)

See Also:
Host: i386-pc-linux-gnu
Target: i386-pc-linux-gnu
Build: i386-pc-linux-gnu
Known to work:
Known to fail:
Last reconfirmed:


Attachments
type32.f (2.40 KB, application/octet-stream)
2003-05-21 15:17 UTC, werner.koerner
Details

Note You need to log in before you can comment on or make changes to this bug.
Description werner.koerner 2002-08-22 03:56:00 UTC
When compiling the attached file using the command:

g77-3.2 -v -c --save-temps -W -Wall -O2 -ffloat-store type32.f 

an internal compiler error occurs. The output of g77 is:

Reading specs from /usr/lib/gcc-lib/i386-linux/3.2/specs
Configured with: /mnt/data/gcc-3.1/gcc-3.2-3.2ds0/src/configure -v --enable-languages=c,c++,java,f77,proto,objc,ada --prefix=/usr --mandir=/usr/share/man --infodir=/usr/share/info --with-gxx-include-dir=/usr/include/c++/3.2 --enable-shared --with-system-zlib --enable-nls --without-included-gettext --enable-__cxa_atexit --enable-java-gc=boehm --enable-objc-gc i386-linux
Thread model: posix
gcc version 3.2 20020809 (Debian prerelease)
 /usr/lib/gcc-lib/i386-linux/3.2/f771 type32.f -quiet -dumpbase type32.f -O2 -W -Wall -version -ffloat-store -o type32.s
GNU F77 version 3.2 20020809 (Debian prerelease) (i386-linux)
	compiled by GNU C version 3.2 20020809 (Debian prerelease).
type32.f: In subroutine `type32':
type32.f:79: warning: `__g77_ASSIGN_ijp' might be used uninitialized in this function
type32.f:101: warning: `__g77_ASSIGN_imp' might be used uninitialized in this function
type32.f:104: warning: `__g77_ASSIGN_inp' might be used uninitialized in this function
type32.f:216: warning: `iter1' might be used uninitialized in this function
type32.f:219: warning: `__g77_ASSIGN_iop' might be used uninitialized in this function
type32.f:260: Internal compiler error in compensate_edge, at reg-stack.c:2591

Release:
unknown

Environment:
System: Linux zaex02 2.4.19 #1 Mit Aug 21 11:47:24 CEST 2002 i686 unknown unknown GNU/Linux
Architecture: i686
host: i386-pc-linux-gnu
build: i386-pc-linux-gnu
target: i386-pc-linux-gnu
configured with: /mnt/data/gcc-3.1/gcc-3.2-3.2ds0/src/configure -v --enable-languages=c,c++,java,f77,proto,objc,ada --prefix=/usr --mandir=/usr/share/man --infodir=/usr/share/info --with-gxx-include-dir=/usr/include/c++/3.2 --enable-shared --with-system-zlib --enable-nls --without-included-gettext --enable-__cxa_atexit --enable-java-gc=boehm --enable-objc-gc i386-linux

How-To-Repeat:
Compile the attached file type32.f with the options -O2 -ffloat-store
Comment 1 Toon Moene 2002-08-22 13:46:13 UTC
State-Changed-From-To: open->analyzed
State-Changed-Why: Jan, this fails on a x86 linux system.  I dumped mine a few
    weeks ago in favor of this Titanium PowerBook, so I can't
    look into it.  However, it crashes in reg-stack.c's
    compensate_edge, at the code following the comment:
    
    /* We don't support abnormal edges ...
    
    currently at line 2581.
    
    Could you look into this ?  Thanks - Toon
Comment 2 jmdavis 2002-09-19 08:44:42 UTC
From: bud davis <jmdavis@link.com>
To: gcc-gnats@gcc.gnu.org, gcc-prs@gcc.gnu.org,
	 werner.koerner@zae.uni-wuerzburg.de, jh@suse.cz,
	 gcc-bugs@gcc.gnu.org, nobody@gcc.gnu.org
Cc:  
Subject: Re: fortran/7681: ICE in compensate_edge, at reg-stack.c:2591
Date: Thu, 19 Sep 2002 08:44:42 -0500

 --------------5A41B35F23F991B621C16563
 Content-Type: text/plain; charset=us-ascii
 Content-Transfer-Encoding: 7bit
 
 Note that this code uses assigned goto's, and compiles if the option
 "-fugly-assign" is added.
 
 --bud davis
 
 
 
 http://gcc.gnu.org/cgi-bin/gnatsweb.pl?cmd=view%20audit-trail&database=gcc&pr=7681
 
 
 
 --------------5A41B35F23F991B621C16563
 Content-Type: text/html; charset=us-ascii
 Content-Transfer-Encoding: 7bit
 
 <!doctype html public "-//w3c//dtd html 4.0 transitional//en">
 <html>
 Note that this code uses assigned goto's, and compiles if the option "-fugly-assign"
 is added.
 <p>--bud davis
 <br>&nbsp;
 <br>&nbsp;
 <pre><A HREF="http://gcc.gnu.org/cgi-bin/gnatsweb.pl?cmd=view%20audit-trail&database=gcc&pr=7681">http://gcc.gnu.org/cgi-bin/gnatsweb.pl?cmd=view%20audit-trail&amp;database=gcc&amp;pr=7681</A></pre>
 &nbsp;</html>
 
 --------------5A41B35F23F991B621C16563--
 
Comment 3 Toon Moene 2003-01-15 07:21:15 UTC
State-Changed-From-To: analyzed->closed
State-Changed-Why: This has recently been solved on the CVS trunk.
Comment 4 Toon Moene 2003-01-30 19:12:52 UTC
From: toon@gcc.gnu.org
To: gcc-gnats@gcc.gnu.org
Cc:  
Subject: fortran/7681
Date: 30 Jan 2003 19:12:52 -0000

 CVSROOT:	/cvs/gcc
 Module name:	gcc
 Branch: 	gcc-3_3-branch
 Changes by:	toon@gcc.gnu.org	2003-01-30 19:12:52
 
 Modified files:
 	gcc/f          : ChangeLog news.texi 
 
 Log message:
 	2003-01-30  Toon Moene  <toon@moene.indiv.nluug.nl>
 	
 	* news.texi: Document fixing PR fortran/7681
 	and PR optimization/9258.
 
 Patches:
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/f/ChangeLog.diff?cvsroot=gcc&only_with_tag=gcc-3_3-branch&r1=1.503.2.10&r2=1.503.2.11
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/f/news.texi.diff?cvsroot=gcc&only_with_tag=gcc-3_3-branch&r1=1.92.2.4&r2=1.92.2.5
 

Comment 5 Toon Moene 2003-01-31 18:43:08 UTC
From: toon@gcc.gnu.org
To: gcc-gnats@gcc.gnu.org
Cc:  
Subject: fortran/7681
Date: 31 Jan 2003 18:43:08 -0000

 CVSROOT:	/cvs/gcc
 Module name:	gcc
 Changes by:	toon@gcc.gnu.org	2003-01-31 18:43:08
 
 Modified files:
 	gcc/f          : ChangeLog news.texi 
 
 Log message:
 	2003-01-31  Toon Moene  <toon@moene.indiv.nluug.nl>
 	
 	* news.texi: Document fixing PR fortran/7681
 	and optimization/9258.
 
 Patches:
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/f/ChangeLog.diff?cvsroot=gcc&r1=1.519&r2=1.520
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/f/news.texi.diff?cvsroot=gcc&r1=1.98&r2=1.99
 

Comment 6 Toon Moene 2003-02-15 14:32:25 UTC
From: toon@gcc.gnu.org
To: gcc-gnats@gcc.gnu.org
Cc:  
Subject: fortran/7681
Date: 15 Feb 2003 14:32:25 -0000

 CVSROOT:	/cvs/gcc
 Module name:	gcc
 Branch: 	gcc-3_3-branch
 Changes by:	toon@gcc.gnu.org	2003-02-15 14:32:24
 
 Modified files:
 	gcc            : ChangeLog global.c 
 
 Log message:
 	2003-02-15  Jan Hubicka  <jh@suse.cz>
 	
 	PR optimization/9258, PR fortran/7681
 	* global.c (struct allocno): Add no_stack_reg.
 	(global_conflicts): Set it.
 	(find_reg): Use it.
 
 Patches:
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/ChangeLog.diff?cvsroot=gcc&only_with_tag=gcc-3_3-branch&r1=1.16114.2.188&r2=1.16114.2.189
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/global.c.diff?cvsroot=gcc&only_with_tag=gcc-3_3-branch&r1=1.87&r2=1.87.2.1